<template>
  <div
    v-if="app === 'interview'"
    class="w-full max-w-[824px] h-[195px] flex flex-row rounded-none relative mx-0 shadow
      sm:rounded-[15px] sm:my-2 md:my-6 overflow-hidden"
  >
    <div
      class="absolute z-20 flex flex-col justify-center items-center w-full h-full my-auto text-center gap-2
        sm:w-1/2 sm:static sm:items-start p-4 sm:!p-6 sm:pb-8 sm:gap-6 sm:!text-start text-very-light-grey sm:!text-fake-black"
    >
      <svn-title h2 semi-bold :color="isMobile ? 'white' : 'fake-black'">
        {{ 'Hello, ' + firstname + '! 👋' }}
      </svn-title>

      <svn-text base medium :color="isMobile ? 'white' : 'fake-black'">
        {{ (subtitle) }}
      </svn-text>
    </div>

    <div class="absolute w-full h-full bg-fakeBlack opacity-60 z-10 sm:opacity-0 bg-blend-multiply" />

    <v-img
      v-if="url"
      class="w-1/2"
      :src="url"
      cover
    />
  </div>

  <div
    v-else-if="app === 'learn'"
    class="flex flex-col gap-y-4"
  >
    <div class="flex flex-row self-center gap-x-2 items-center">
      <svn-title h1 semi-bold class="text-center">
        {{ ('Hello, ' + firstname + '! 👋') }}
      </svn-title>
    </div>

    <div class="flex flex-col sm:!flex-row justify-center items-center gap-2">
      <svn-header-chip
        icon="noto:smiling-face-with-sunglasses"
        :text="completedTrainings"
        :append-text="textChipFirst"
      />

      <svn-header-chip
        icon="noto:open-book"
        :text="modulesAcquired"
        :append-text="textChipSecond"
      />
    </div>
  </div>

  <div
    v-else-if="app === 'roadmap'"
    class="flex flex-col gap-y-4"
  >
    <div class="flex flex-row self-center gap-x-2 items-center">
      <svn-title h1 semi-bold class="text-center">
        {{ ('Hello, ' + firstname + '! 👋') }}
      </svn-title>
    </div>

    <div class="flex flex-col sm:!flex-row justify-center items-center gap-2">
      <svn-header-chip
        icon="noto:smiling-face-with-sunglasses"
        :text="completedTargets"
        :append-text="textChipFirst"
      />

      <svn-header-chip
        icon="noto:bullseye"
        :text="currentTargets"
        :append-text="textChipSecond"
      />
    </div>
  </div>

  <div
    v-else-if="app === 'home'"
    class="flex flex-col items-center self-stretch gap-4"
  >
    <div class="flex items-center justify-center gap-2">
      <svn-title h1 semi-bold>
        {{ firstname }}!
      </svn-title>

      <div>
        <Icon
          icon="noto:waving-hand"
          height="32"
          width="32"
        />
      </div>
    </div>

    <div class="flex justify-center items-start content-start gap-2 self-stretch flex-wrap">
      <svn-header-chip
        v-if="applications?.includes('interviews')"
        icon="noto:speech-balloon"
        :text="interviewsSubmitted"
        :append-text="textChipThird"
      />

      <svn-header-chip
        v-if="applications?.includes('trainings')"
        icon="noto:open-book"
        :text="modulesAcquired"
        :append-text="textChipFirst"
      />

      <svn-header-chip
        v-if="applications?.includes('objectives')"
        icon="noto:bullseye"
        :text="currentTargets"
        :append-text="textChipSecond"
      />
    </div>
  </div>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import { onMounted, onUnmounted, ref } from "vue";
import SvnHeaderChip from '../chip/SvnHeaderChip.vue';
import SvnTitle from '../styles/SvnTitle.vue';
import SvnText from '../styles/SvnText.vue';

// Props
const props = defineProps({
  app: { type: String, default: 'interview' },
  url: { type: String, default: null },
  firstname: { type: String, default: null },
  subtitle: { type: String, default: null },
  applications: { type: Array, default: () => {} },
  interviewsSubmitted: { type: Number, default: null },
  completedTrainings: { type: Number, default: null },
  modulesAcquired: { type: Number, default: null },
  completedTargets: { type: Number, default: null },
  currentTargets: { type: Number, default: null },
  textChipFirst: { type: String, default: "Trainings completed" },
  textChipSecond: { type: String, default: "Modules acquired" },
  textChipThird: { type: String, default: "Interviews submitted" },
})

// Refs
const isMobile = ref(false)

onMounted(() => {
  isMobile.value = window.innerWidth < 640
  window.addEventListener("resize", handleWindowResize)
})

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize)
})

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 640
}
</script>

<style scoped>
.shadow {
  box-shadow: 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>
